package cn.axzo.workflow.server.controller.delegate;

import cn.axzo.karma.client.feign.FlowSupportApi;
import cn.axzo.karma.client.model.request.ListFlowTaskAssignerReq;
import cn.axzo.karma.client.model.response.FlowTaskAssignerResp;
import cn.axzo.workflow.common.enums.ApproverSpecifyEnum;
import cn.axzo.workflow.common.model.request.bpmn.task.BpmnTaskDelegateAssigner;
import cn.axzo.workflow.core.deletage.approverscope.ApproverScopeDTO;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.ListUtils;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 基于"身份"查询审批人
 *
 * @author wangli
 * @since 2023/11/16 11:38
 */
@Slf4j
@Component
public class BasedIdentityTaskAssigneeSelector extends AbstractBpmnTaskAssigneeSelector {

    @Autowired
    private FlowSupportApi flowSupportApi;

    @Override
    public String getType() {
        return ApproverSpecifyEnum.identity.getType();
    }

    @Override
    public boolean support(String param) {
        return getType().equals(param);
    }

    @Override
    public List<BpmnTaskDelegateAssigner> select(FlowElement flowElement, DelegateExecution execution,
                                                 Boolean throwException) {
        return super.select(flowElement, execution, throwException);
    }

    @Override
    protected List<BpmnTaskDelegateAssigner> invokeService(FlowElement flowElement, DelegateExecution execution,
                                                           ApproverScopeDTO scopeDto) {
        ListFlowTaskAssignerReq req = ListFlowTaskAssignerReq.builder()
                .orgScopes(ListUtils.emptyIfNull(scopeDto.getOrgScopes()).stream()
                        .map(e -> BeanUtil.copyProperties(e, ListFlowTaskAssignerReq.OrgScope.class))
                        .collect(Collectors.toList()))
                .workerTeamScopes(ListUtils.emptyIfNull(scopeDto.getWorkerTeamScopes()).stream()
                        .map(w -> BeanUtil.copyProperties(w, ListFlowTaskAssignerReq.OrgScope.class))
                        .collect(Collectors.toList()))
                .identityCodes(super.getTypes(flowElement))
                .build();

        List<FlowTaskAssignerResp> flowTaskAssigners =
                parseApiResult(() -> flowSupportApi.listTaskAssignerByIdentity(req),
                        "审批节点: " + flowElement.getId() + ", 通过身份查询审批人",
                        "cn.axzo.karma.client.feign.FlowSupportApi.listTaskAssignerByIdentity", req);

        if (CollUtil.isEmpty(flowTaskAssigners)) {
            return super.invokeService(flowElement, execution, scopeDto);
        }
        return BeanUtil.copyToList(flowTaskAssigners, BpmnTaskDelegateAssigner.class);
    }
}
